blob: a2287897018f5c25002c5ccb83e4542dc421d5cd [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Nicolas Geoffray1c5b6da2016-03-16 10:55:57 +000048export USE_JACK="true"
Alex Lightb55f1ac2016-04-12 15:50:55 -070049export SMALI_ARGS="--experimental"
jeffhao5d1ac922011-09-29 17:41:15 -070050
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070051# If dx was not set by the environment variable, assume it is in the path.
52if [ -z "$DX" ]; then
53 export DX="dx"
54fi
55
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080056# If jasmin was not set by the environment variable, assume it is in the path.
57if [ -z "$JASMIN" ]; then
58 export JASMIN="jasmin"
59fi
60
Andreas Gampe8fda9f22014-10-03 16:15:37 -070061# If smali was not set by the environment variable, assume it is in the path.
62if [ -z "$SMALI" ]; then
63 export SMALI="smali"
64fi
65
66# If dexmerger was not set by the environment variable, assume it is in the path.
67if [ -z "$DXMERGER" ]; then
68 export DXMERGER="dexmerger"
69fi
70
Sebastien Hertz19ac0272015-02-24 17:39:50 +010071# If jack was not set by the environment variable, assume it is in the path.
72if [ -z "$JACK" ]; then
73 export JACK="jack"
74fi
75
Sebastien Hertz19ac0272015-02-24 17:39:50 +010076# ANDROID_BUILD_TOP is not set in a build environment.
77if [ -z "$ANDROID_BUILD_TOP" ]; then
78 export ANDROID_BUILD_TOP=$oldwd
79fi
80
Andreas Gampef47fb2f2016-06-24 22:30:29 -070081# ANDROID_HOST_OUT is not set in a build environment.
82if [ -z "$ANDROID_HOST_OUT" ]; then
83 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out/}host/linux-x86
84fi
85
Sebastien Hertz19ac0272015-02-24 17:39:50 +010086# If JACK_CLASSPATH is not set, assume it only contains core-libart.
87if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070088 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010089fi
90
Sebastien Hertz19ac0272015-02-24 17:39:50 +010091export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080092
jeffhao5d1ac922011-09-29 17:41:15 -070093info="info.txt"
94build="build"
95run="run"
96expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -070097check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -070098output="output.txt"
99build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100100cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700101strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700102lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700103testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700104run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000105build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700106
Alex Light91de25f2015-10-28 17:00:06 -0700107quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000108debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700109prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700110target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700111dev_mode="no"
112update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700113debug_mode="no"
114relocate="yes"
Jeff Hao201803f2013-11-20 18:11:39 -0800115runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700116usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700117build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700118suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700119trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700120trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700121basic_verify="false"
122gc_verify="false"
123gc_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700124strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700125always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700126never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700127have_dex2oat="yes"
128have_patchoat="yes"
129have_image="yes"
Andreas Gampec23c9c92014-10-28 14:47:25 -0700130pic_image_suffix=""
Jeff Haodcdc85b2015-12-04 14:06:18 -0800131multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000132android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700133bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800134suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700135# By default we will use optimizing.
136image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000137image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700138
139while true; do
140 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700141 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700142 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100143 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700144 shift
Alex Light91de25f2015-10-28 17:00:06 -0700145 elif [ "x$1" = "x--quiet" ]; then
146 quiet="yes"
147 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700148 elif [ "x$1" = "x--use-java-home" ]; then
149 if [ -n "${JAVA_HOME}" ]; then
150 export JAVA="${JAVA_HOME}/bin/java"
151 export JAVAC="${JAVA_HOME}/bin/javac -g"
152 else
153 echo "Passed --use-java-home without JAVA_HOME variable set!"
154 usage="yes"
155 fi
156 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800157 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700158 target_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800159 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700160 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700161 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700162 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100163 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100164 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700165 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700166 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800167 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700168 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700169 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700170 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700171 shift
172 elif [ "x$1" = "x--dalvik" ]; then
173 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800174 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700175 shift
Alex Light03a112d2014-08-25 13:25:56 -0700176 elif [ "x$1" = "x--no-dex2oat" ]; then
177 have_dex2oat="no"
178 shift
179 elif [ "x$1" = "x--no-patchoat" ]; then
180 have_patchoat="no"
181 shift
182 elif [ "x$1" = "x--no-image" ]; then
183 have_image="no"
184 shift
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000185 elif [ "x$1" = "x--npic-image" ]; then
186 pic_image_suffix="-npic"
Andreas Gampec23c9c92014-10-28 14:47:25 -0700187 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800188 elif [ "x$1" = "x--multi-image" ]; then
189 multi_image_suffix="-multi"
190 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700191 elif [ "x$1" = "x--pic-test" ]; then
192 run_args="${run_args} --pic-test"
193 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700194 elif [ "x$1" = "x--relocate" ]; then
195 relocate="yes"
196 shift
197 elif [ "x$1" = "x--no-relocate" ]; then
198 relocate="no"
199 shift
200 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100201 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700202 prebuild_mode="yes"
203 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700204 elif [ "x$1" = "x--strip-dex" ]; then
205 run_args="${run_args} --strip-dex"
206 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000207 elif [ "x$1" = "x--debuggable" ]; then
208 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000209 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000210 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700211 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100212 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700213 prebuild_mode="no"
214 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700215 elif [ "x$1" = "x--gcverify" ]; then
216 basic_verify="true"
217 gc_verify="true"
218 shift
219 elif [ "x$1" = "x--gcstress" ]; then
220 basic_verify="true"
221 gc_stress="true"
222 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800223 elif [ "x$1" = "x--suspend-timeout" ]; then
224 shift
225 suspend_timeout="$1"
226 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700227 elif [ "x$1" = "x--image" ]; then
228 shift
229 image="$1"
230 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700231 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000232 elif [ "x$1" = "x-Xcompiler-option" ]; then
233 shift
234 option="$1"
235 run_args="${run_args} -Xcompiler-option $option"
236 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700237 elif [ "x$1" = "x--runtime-option" ]; then
238 shift
239 option="$1"
240 run_args="${run_args} --runtime-option $option"
241 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700242 elif [ "x$1" = "x--gdb-arg" ]; then
243 shift
244 gdb_arg="$1"
245 run_args="${run_args} --gdb-arg $gdb_arg"
246 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700247 elif [ "x$1" = "x--debug" ]; then
248 run_args="${run_args} --debug"
249 shift
250 elif [ "x$1" = "x--gdb" ]; then
251 run_args="${run_args} --gdb"
252 dev_mode="yes"
253 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700254 elif [ "x$1" = "x--strace" ]; then
255 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700256 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700257 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700258 elif [ "x$1" = "x--zygote" ]; then
259 run_args="${run_args} --zygote"
260 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800261 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000262 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700263 image_suffix="-interpreter"
264 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800265 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700266 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000267 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800268 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700269 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700270 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800271 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700272 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700273 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700274 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700275 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700276 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700277 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700278 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700279 elif [ "x$1" = "x--no-optimize" ]; then
280 run_args="${run_args} --no-optimize"
281 shift
282 elif [ "x$1" = "x--no-precise" ]; then
283 run_args="${run_args} --no-precise"
284 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700285 elif [ "x$1" = "x--invoke-with" ]; then
286 shift
287 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700288 if [ "x$what" = "x" ]; then
289 echo "$0 missing argument to --invoke-with" 1>&2
290 usage="yes"
291 break
292 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700293 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700294 shift
295 elif [ "x$1" = "x--dev" ]; then
296 run_args="${run_args} --dev"
297 dev_mode="yes"
298 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700299 elif [ "x$1" = "x--build-only" ]; then
300 build_only="yes"
301 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100302 elif [ "x$1" = "x--build-with-javac-dx" ]; then
303 USE_JACK="false"
304 shift
305 elif [ "x$1" = "x--build-with-jack" ]; then
306 USE_JACK="true"
307 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700308 elif [ "x$1" = "x--output-path" ]; then
309 shift
310 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700311 if [ "x$tmp_dir" = "x" ]; then
312 echo "$0 missing argument to --output-path" 1>&2
313 usage="yes"
314 break
315 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700316 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000317 elif [ "x$1" = "x--android-root" ]; then
318 shift
319 if [ "x$1" = "x" ]; then
320 echo "$0 missing argument to --android-root" 1>&2
321 usage="yes"
322 break
323 fi
324 android_root="$1"
325 run_args="${run_args} --android-root $1"
326 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700327 elif [ "x$1" = "x--update" ]; then
328 update_mode="yes"
329 shift
330 elif [ "x$1" = "x--help" ]; then
331 usage="yes"
332 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700333 elif [ "x$1" = "x--64" ]; then
334 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700335 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700336 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200337 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700338 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200339 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700340 elif [ "x$1" = "x--stream" ]; then
341 trace_stream="true"
342 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700343 elif [ "x$1" = "x--always-clean" ]; then
344 always_clean="yes"
345 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700346 elif [ "x$1" = "x--never-clean" ]; then
347 never_clean="yes"
348 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800349 elif [ "x$1" = "x--dex2oat-swap" ]; then
350 run_args="${run_args} --dex2oat-swap"
351 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700352 elif [ "x$1" = "x--instruction-set-features" ]; then
353 shift
354 run_args="${run_args} --instruction-set-features $1"
355 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700356 elif [ "x$1" = "x--bisection-search" ]; then
357 bisection_search="yes"
358 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000359 elif [ "x$1" = "x--vdex" ]; then
360 run_args="${run_args} --vdex"
361 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000362 elif [ "x$1" = "x--vdex-filter" ]; then
363 shift
364 filter=$1
365 run_args="${run_args} --vdex-filter $filter"
366 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700367 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700368 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700369 usage="yes"
370 break
371 else
372 break
373 fi
374done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700375
Alex Light10bc5a42016-05-10 10:01:22 -0700376run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700377# Allocate file descriptor real_stderr and redirect it to the shell's error
378# output (fd 2).
379if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
380 exec {real_stderr}>&2
381else
382 # In bash before version 4.1 we need to do a manual search for free file
383 # descriptors.
384 FD=3
385 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
386 real_stderr=$FD
387 eval "exec ${real_stderr}>&2"
388fi
389if [ "$quiet" = "yes" ]; then
390 # Force the default standard output and error to go to /dev/null so we will
391 # not print them.
392 exec 1>/dev/null
393 exec 2>/dev/null
394fi
395
396function err_echo() {
397 echo "$@" 1>&${real_stderr}
398}
399
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700400# tmp_dir may be relative, resolve.
401#
402# Cannot use realpath, as it does not exist on Mac.
403# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700404# Cannot use readlink -m, as it does not exist on Mac.
405# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700406noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700407tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700408mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700409
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800410# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000411if [ ! "$runtime" = "jvm" ]; then
412 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
413fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800414
Alex Lighte7873ec2014-08-12 09:53:50 -0700415if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800416 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
417 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700418fi
419if [ "$gc_verify" = "true" ]; then
420 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
421fi
422if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700423 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700424fi
Jeff Hao85139a32014-07-23 11:52:52 -0700425if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700426 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
427 if [ "$trace_stream" = "true" ]; then
428 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
429 # the ability to analyze the file and just write to /dev/null.
430 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
431 # Enable streaming mode.
432 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
433 else
434 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
435 fi
436elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700437 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700438 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700439fi
440
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700441# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100442# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100443function guess_target_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100444 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800445 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700446 if [ "x${suffix64}" = "x64" ]; then
447 target_arch_name=${grep64bit}
448 else
449 target_arch_name=${grep32bit}
450 fi
451}
452
David Brazdil853a4c32015-09-28 16:15:50 +0100453function guess_host_arch_name() {
454 if [ "x${suffix64}" = "x64" ]; then
455 host_arch_name="x86_64"
456 else
457 host_arch_name="x86"
458 fi
459}
460
Alex Lighta59dd802014-07-02 16:28:08 -0700461if [ "$target_mode" = "no" ]; then
462 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700463 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700464 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700465 exit 1;
466 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700467 fi
468fi
469
Alex Light03a112d2014-08-25 13:25:56 -0700470if [ "$have_patchoat" = "no" ]; then
471 run_args="${run_args} --no-patchoat"
472fi
473
474if [ "$have_dex2oat" = "no" ]; then
475 run_args="${run_args} --no-dex2oat"
476fi
477
Jeff Hao201803f2013-11-20 18:11:39 -0800478if [ ! "$runtime" = "jvm" ]; then
479 run_args="${run_args} --lib $lib"
480fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700481
Jeff Hao201803f2013-11-20 18:11:39 -0800482if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700483 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100484 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800485 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700486 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700487 else
488 true # defaults to using target BOOTCLASSPATH
489 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800490elif [ "$runtime" = "art" ]; then
491 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100492 guess_host_arch_name
Jeff Haodcdc85b2015-12-04 14:06:18 -0800493 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700494 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800495 else
David Brazdil853a4c32015-09-28 16:15:50 +0100496 guess_target_arch_name
Nicolas Geoffrayf13a3652016-09-22 22:55:58 +0100497 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}:${android_root}/lib${suffix64}"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800498 run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800499 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700500 if [ "$relocate" = "yes" ]; then
501 run_args="${run_args} --relocate"
502 else
503 run_args="${run_args} --no-relocate"
504 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700505elif [ "$runtime" = "jvm" ]; then
506 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800507 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700508fi
509
Alex Light03a112d2014-08-25 13:25:56 -0700510if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700511 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700512 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700513 exit 1
514 fi
515 if [ "$target_mode" = "no" ]; then
516 framework="${ANDROID_HOST_OUT}/framework"
517 bpath_suffix="-hostdex"
518 else
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000519 framework="${android_root}/framework"
Alex Light1ef4ce82014-08-27 11:13:47 -0700520 bpath_suffix=""
521 fi
522 # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will
523 # fail since these jar files will be stripped.
524 bpath="${framework}/core-libart${bpath_suffix}.jar"
Narayan Kamathd50687e2015-11-17 12:37:27 +0000525 bpath="${bpath}:${framework}/core-oj${bpath_suffix}.jar"
Alex Light1ef4ce82014-08-27 11:13:47 -0700526 bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar"
527 bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar"
Alex Light1ef4ce82014-08-27 11:13:47 -0700528 bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar"
529 # Pass down the bootclasspath
530 run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}"
Alex Light03a112d2014-08-25 13:25:56 -0700531 run_args="${run_args} --no-image"
532fi
533
jeffhao5d1ac922011-09-29 17:41:15 -0700534if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700535 err_echo "--dev and --update are mutually exclusive"
536 usage="yes"
537fi
538
539if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
540 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700541 usage="yes"
542fi
543
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700544if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
545 err_echo "--bisection-search and --prebuild are mutually exclusive"
546 usage="yes"
547fi
548
549if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
550 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
551 usage="yes"
552fi
553
554if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
555 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
556 usage="yes"
557fi
558
jeffhao5d1ac922011-09-29 17:41:15 -0700559if [ "$usage" = "no" ]; then
560 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
561 test_dir=`basename "$oldwd"`
562 else
563 test_dir="$1"
564 fi
565
566 if [ '!' -d "$test_dir" ]; then
567 td2=`echo ${test_dir}-*`
568 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700569 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700570 usage="yes"
571 fi
572 test_dir="$td2"
573 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700574 # Shift to get rid of the test name argument. The rest of the arguments
575 # will get passed to the test run.
576 shift
577fi
578
Søren Gjesse620d0a52016-09-19 11:12:51 +0200579# For building with javac and dx always use Java 7. The dx compiler
580# only support byte codes from Java 7 or earlier (class file major
581# version 51 or lower).
582if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
583 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
584fi
585
jeffhao5d1ac922011-09-29 17:41:15 -0700586if [ "$usage" = "yes" ]; then
587 prog=`basename $prog`
588 (
589 echo "usage:"
590 echo " $prog --help Print this message."
591 echo " $prog [options] [test-name] Run test normally."
592 echo " $prog --dev [options] [test-name] Development mode" \
593 "(dumps to stdout)."
594 echo " $prog --update [options] [test-name] Update mode" \
595 "(replaces expected.txt)."
596 echo ' Omitting the test name or specifying "-" will use the' \
597 "current directory."
598 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000599 echo " -O Run non-debug rather than debug build (off by default)."
600 echo " -Xcompiler-option Pass an option to the compiler."
601 echo " --runtime-option Pass an option to the runtime."
602 echo " --debug Wait for a debugger to attach."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000603 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000604 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700605 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000606 echo " --build-only Build test files only (off by default)."
Søren Gjesse620d0a52016-09-19 11:12:51 +0200607 echo " --build-with-javac-dx Build test files with javac and dx (off by default)."
608 echo " --build-with-jack Build test files with jack and jill (on by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000609 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800610 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000611 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000612 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700613 echo " --verify-soft-fail Force soft fail verification (off by default)."
614 echo " Verification is enabled if neither --no-verify"
615 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000616 echo " --no-optimize Turn off optimization (on by default)."
617 echo " --no-precise Turn off precise GC (on by default)."
618 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700619 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000620 echo " other runtime options are ignored."
621 echo " --no-dex2oat Run as though dex2oat was failing."
622 echo " --no-patchoat Run as though patchoat was failing."
623 echo " --prebuild Run dex2oat on the files before starting test. (default)"
624 echo " --no-prebuild Do not run dex2oat on the files before starting"
625 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700626 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000627 echo " --relocate Force the use of relocating in the test, making"
628 echo " the image and oat files be relocated to a random"
629 echo " address before running. (default)"
630 echo " --no-relocate Force the use of no relocating in the test"
Alex Lightfadfee92015-10-28 09:40:10 -0700631 echo " --image Run the test using a precompiled boot image. (default)"
632 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000633 echo " --host Use the host-mode virtual machine."
634 echo " --invoke-with Pass --invoke-with option to runtime."
635 echo " --dalvik Use Dalvik (off by default)."
636 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700637 echo " --use-java-home Use the JAVA_HOME environment variable"
638 echo " to find the java compiler and runtime"
639 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000640 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700641 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000642 echo " --64 Run the test in 64-bit mode"
643 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700644 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700645 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000646 echo " --gcstress Run with gc stress testing"
647 echo " --gcverify Run with gc verification"
648 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700649 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000650 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000651 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700652 echo " --instruction-set-features [string]"
653 echo " Set instruction-set-features for compilation."
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000654 echo " --npic-image Use an image compiled with non-position independent code "
655 echo " for the boot class path."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800656 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
657 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700658 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700659 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700660 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000661 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800662 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Alex Light91de25f2015-10-28 17:00:06 -0700663 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700664 exit 1
665fi
666
667cd "$test_dir"
668test_dir=`pwd`
669
670td_info="${test_dir}/${info}"
671td_expected="${test_dir}/${expected}"
672
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700673if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700674 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700675 exit 1
676fi
677
678if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700679 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700680 exit 1
681fi
682
683# copy the test to a temp dir and run it
684
Elliott Hughes510c8782011-10-06 10:57:34 -0700685echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700686
687rm -rf "$tmp_dir"
688cp -Rp "$test_dir" "$tmp_dir"
689cd "$tmp_dir"
690
691if [ '!' -r "$build" ]; then
692 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800693else
694 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700695fi
696
697if [ '!' -r "$run" ]; then
698 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800699else
700 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700701fi
702
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700703if [ '!' -r "$check_cmd" ]; then
704 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800705else
706 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700707fi
708
jeffhao5d1ac922011-09-29 17:41:15 -0700709chmod 755 "$build"
710chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700711chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700712
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700713export TEST_NAME=`basename ${test_dir}`
714
Roland Levillain0d5a2812015-11-13 10:07:31 +0000715# arch_supports_read_barrier ARCH
716# -------------------------------
717# Return whether the Optimizing compiler has read barrier support for ARCH.
718function arch_supports_read_barrier() {
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000719 # Optimizing has read barrier support for ARM, ARM64, x86 and x86-64 at the
Roland Levillain0d5a2812015-11-13 10:07:31 +0000720 # moment.
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000721 [ "x$1" = xarm ] || [ "x$1" = xarm64 ] || [ "x$1" = xx86 ] || [ "x$1" = xx86_64 ]
Roland Levillain0d5a2812015-11-13 10:07:31 +0000722}
723
David Brazdil4846d132015-01-15 19:07:08 +0000724# Tests named '<number>-checker-*' will also have their CFGs verified with
725# Checker when compiled with Optimizing on host.
726if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000727 if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$USE_JACK" = "true" ]; then
Roland Levillain0d5a2812015-11-13 10:07:31 +0000728 # Optimizing has read barrier support for certain architectures
729 # only. On other architectures, compiling is disabled when read
730 # barriers are enabled, meaning that we do not produce a CFG file
731 # as a side-effect of compilation, thus the Checker assertions
732 # cannot be checked. Disable Checker for those cases.
733 #
734 # TODO: Enable Checker when read barrier support is added to more
735 # architectures (b/12687968).
Hiroshi Yamauchifd3161a2017-01-18 14:47:25 -0800736 if [ "x$ART_USE_READ_BARRIER" != xfalse ] \
Roland Levillain0d5a2812015-11-13 10:07:31 +0000737 && (([ "x$host_mode" = "xyes" ] \
738 && ! arch_supports_read_barrier "$host_arch_name") \
739 || ([ "x$target_mode" = "xyes" ] \
740 && ! arch_supports_read_barrier "$target_arch_name")); then
741 run_checker="no"
David Brazdil80fb3942015-07-23 11:53:42 +0100742 # In no-prebuild mode, the compiler is only invoked if both dex2oat and
743 # patchoat are available. Disable Checker otherwise (b/22552692).
Roland Levillain0d5a2812015-11-13 10:07:31 +0000744 elif [ "$prebuild_mode" = "yes" ] \
745 || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then
David Brazdil80fb3942015-07-23 11:53:42 +0100746 run_checker="yes"
David Brazdil5cc343d2015-10-08 11:35:32 +0100747
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100748 if [ "$target_mode" = "no" ]; then
749 cfg_output_dir="$tmp_dir"
David Brazdil5cc343d2015-10-08 11:35:32 +0100750 checker_args="--arch=${host_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100751 else
752 cfg_output_dir="$DEX_LOCATION"
David Brazdil5cc343d2015-10-08 11:35:32 +0100753 checker_args="--arch=${target_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100754 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100755
756 if [ "$debuggable" = "yes" ]; then
757 checker_args="$checker_args --debuggable"
758 fi
759
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100760 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
David Brazdil80fb3942015-07-23 11:53:42 +0100761 -Xcompiler-option -j1"
762 fi
David Brazdil4846d132015-01-15 19:07:08 +0000763 fi
764fi
765
Mathieu Chartier031768a2015-08-27 10:25:02 -0700766 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700767
Ian Rogers997f0f92014-06-21 22:58:05 -0700768# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB.
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100769build_file_size_limit=2048
770run_file_size_limit=2048
Alex Light4694e822016-01-22 10:09:40 -0800771
772# Add tests requiring a higher ulimit to this list. Ulimits might need to be raised to deal with
773# large amounts of expected output or large generated files.
774if echo "$test_dir" | grep -Eq "(083|089|961|964|971)" > /dev/null; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100775 build_file_size_limit=5120
776 run_file_size_limit=5120
Ian Rogers997f0f92014-06-21 22:58:05 -0700777fi
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100778if [ "$run_checker" = "yes" -a "$target_mode" = "yes" ]; then
779 # We will need to `adb pull` the .cfg output from the target onto the host to
780 # run checker on it. This file can be big.
Nicolas Geoffray4151eff2016-11-06 14:24:08 +0000781 build_file_size_limit=32768
782 run_file_size_limit=32768
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100783fi
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100784if [ ${USE_JACK} = "false" ]; then
785 # Set ulimit if we build with dx only, Jack can generate big temp files.
786 if ! ulimit -S "$build_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700787 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100788 fi
Ian Rogers997f0f92014-06-21 22:58:05 -0700789fi
790
jeffhao5d1ac922011-09-29 17:41:15 -0700791good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000792good_build="yes"
793good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700794if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000795 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700796 build_exit="$?"
797 echo "build exit status: $build_exit" 1>&2
798 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100799 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700800 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100801 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800802 echo "${test_dir}: running..." 1>&2
803 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700804 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000805
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800806 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000807 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100808 if [ "$target_mode" = "yes" ]; then
809 adb pull $cfg_output_dir/$cfg_output &> /dev/null
810 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100811 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000812 checker_exit="$?"
813 if [ "$checker_exit" = "0" ]; then
814 good="yes"
815 fi
Alex Light91de25f2015-10-28 17:00:06 -0700816 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000817 else
818 good="yes"
819 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800820 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000821 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700822 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700823elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000824 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700825 build_exit="$?"
826 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100827 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700828 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100829 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800830 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700831 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000832 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100833 if [ "$target_mode" = "yes" ]; then
834 adb pull $cfg_output_dir/$cfg_output &> /dev/null
835 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100836 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000837 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700838 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
839 good="yes"
840 else
Alex Light91de25f2015-10-28 17:00:06 -0700841 cat "$build_output" 1>&${real_stderr} 1>&2
842 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700843 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700844elif [ "$build_only" = "yes" ]; then
845 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000846 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700847 build_exit="$?"
848 if [ "$build_exit" '!=' '0' ]; then
849 cp "$build_output" "$output"
850 echo "build exit status: $build_exit" >>"$output"
851 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
852 if [ "$?" '!=' "0" ]; then
853 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700854 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700855 fi
856 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700857 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700858 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700859 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700860else
David Brazdil4846d132015-01-15 19:07:08 +0000861 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700862 build_exit="$?"
863 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100864 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700865 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100866 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800867 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700868 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000869 run_exit="$?"
870 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700871 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000872 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000873 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100874 if [ "$target_mode" = "yes" ]; then
875 adb pull $cfg_output_dir/$cfg_output &> /dev/null
876 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100877 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000878 checker_exit="$?"
879 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700880 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000881 good_run="no"
882 else
883 good_run="yes"
884 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000885 else
886 good_run="yes"
887 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700888 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000889 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700890 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700891 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
892 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700893 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700894 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700895 max_name_length=$(getconf NAME_MAX ${tmp_dir})
896 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
897 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700898 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700899 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700900 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700901 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000902 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
903 # output == expected
904 good="yes"
905 echo "${test_dir}: succeeded!" 1>&2
906 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700907 fi
908fi
909
jeffhao5d1ac922011-09-29 17:41:15 -0700910(
Alex Lightbfac14a2014-07-30 09:41:21 -0700911 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700912 echo "${test_dir}: FAILED!"
913 echo ' '
914 echo '#################### info'
915 cat "${td_info}" | sed 's/^/# /g'
916 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700917 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700918 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700919 if [ "$strace" = "yes" ]; then
920 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700921 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700922 echo '####################'
923 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700924 echo ' '
925 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700926
Alex Light91de25f2015-10-28 17:00:06 -0700927) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700928
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700929# Attempt bisection only if the test failed.
930if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
931 # Bisecting works by skipping different optimization passes which breaks checker assertions.
932 if [ "$run_checker" == "yes" ]; then
933 echo "${test_dir}: not bisecting, checker test." 1>&2
934 else
935 # Increase file size limit, bisection search can generate large logfiles.
936 if ! ulimit -S unlimited; then
937 err_echo "ulimit file size setting failed"
938 fi
939 echo "${test_dir}: bisecting..." 1>&2
940 cwd=`pwd`
941 maybe_device_mode=""
942 raw_cmd=""
943 if [ "$target_mode" = "yes" ]; then
944 # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option
945 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
946 # to exec in order to preserve pid when calling dalvikvm. This is required
947 # for bisection search to correctly retrieve logs from device.
948 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
949 adb shell chmod u+x "$DEX_LOCATION/cmdline.sh"
950 maybe_device_mode="--device"
951 raw_cmd="$DEX_LOCATION/cmdline.sh"
952 else
953 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
954 fi
955 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
956 $maybe_device_mode \
957 --raw-cmd="$raw_cmd" \
958 --check-script="$cwd/check" \
959 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -0700960 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700961 --timeout=300
962 fi
963fi
964
Alex Lightbfac14a2014-07-30 09:41:21 -0700965# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -0700966if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -0700967 cd "$oldwd"
968 rm -rf "$tmp_dir"
969 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
970 adb shell rm -rf $DEX_LOCATION
971 fi
972 if [ "$good" = "yes" ]; then
973 exit 0
974 fi
975fi
976
977
978(
979 if [ "$always_clean" = "yes" ]; then
980 echo "${TEST_NAME} files deleted from host "
981 if [ "$target_mode" == "yes" ]; then
982 echo "and from target"
983 fi
984 else
985 echo "${TEST_NAME} files left in ${tmp_dir} on host"
986 if [ "$target_mode" == "yes" ]; then
987 echo "and in ${DEX_LOCATION} on target"
988 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700989 fi
990
Alex Light91de25f2015-10-28 17:00:06 -0700991) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700992
Alex Light6a870fa2016-05-31 16:36:19 -0700993if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
994 exit 0
995else
996 exit 1
997fi